-- Script ini terbuka untuk semua, dipersilahkan kepada siapapun yg mau kembangkan, dan jangan lupa cantumkan nama saya: jibran, untuk menghargai usaha saya.
-- Dilarang keras menjual kode script yang terkait dan menghapus kredit asli!

require "import"
import "android.content.*"
import "android.speech.*"
import "android.widget.*"
import "android.content.Intent"
import "android.net.Uri"
import "android.os.Handler"
import "android.os.Looper"
import "java.net.URLEncoder"
import "cjson"

konteks = this or service

function showToast(message)
    Toast.makeText(context, message, Toast.LENGTH_SHORT).show()
end

function vibrate()
    local vibrator = context.getSystemService(Context.VIBRATOR_SERVICE)
    if vibrator then vibrator.vibrate(50) end
end

local function saveConfig(config)
    local prefs = konteks.getSharedPreferences("appConfig", Context.MODE_PRIVATE)
    local editor = prefs.edit()
    editor.putString("apiKey", config.apiKey) -- Simpan API key
    editor.putString("customInstruction", config.customInstruction) -- Simpan instruksi AI kustom
    editor.putBoolean("enableVibration", config.enableVibration) -- Simpan status getar
    editor.putBoolean("autoCopy", config.autoCopy) -- Simpan status salin otomatis
    editor.putBoolean("useGeminiForDictation", config.useGeminiForDictation) -- Simpan status pemrosesan Gemini
    editor.apply()
end

local function loadConfig()
    local prefs = konteks.getSharedPreferences("appConfig", Context.MODE_PRIVATE)
    return {
        apiKey = prefs.getString("apiKey", ""),
        customInstruction = prefs.getString("customInstruction", "Koreksi tulisan berikut dengan tanda baca, dan jangan lupa hapus komentar AI dan instruksi, langsung keluarkan hasil koreksinya."),
        enableVibration = prefs.getBoolean("enableVibration", false), -- Default efek getar: false
        autoCopy = prefs.getBoolean("autoCopy", false), -- Default salin otomatis: false
        useGeminiForDictation = prefs.getBoolean("useGeminiForDictation", true) -- Default pemrosesan dengan Gemini: true
}
end

local config = loadConfig() -- Muat konfigurasi

local function vibrate(duration)
    if config.enableVibration then
        local vibrator = konteks.getSystemService(Context.VIBRATOR_SERVICE)
        if vibrator then
            vibrator.vibrate(duration or 60)
        end
    end
end

local function processText(text)
    vibrate()

    if not config.useGeminiForDictation then
        if config.autoCopy then
            service.paste(text)
        else
            service.insert(service.getEditText(), text)
        end
        service.speak(text)
        return
    end

    local apiKey = config.apiKey
    if apiKey == "" then
        service.speak("API key belum diatur.")
        return text
    end

    local finalPrompt = config.customInstruction.. " Berikut teks yang perlu diproses: ".. text
    local apiUrl = "https://generativelanguage.googleapis.com/v1beta/models/gemini-2.0-flash:generateContent?key=".. apiKey

    local requestData = {
        contents = { { parts = { { text = finalPrompt}}}}
}

    local jsonBody = cjson.encode(requestData)


    Http.post(apiUrl, jsonBody, { ["Content-Type"] = "application/json"}, function(status, response)
        if status == 200 then
            local success, jsonData = pcall(function() return cjson.decode(response) end)
            if success and jsonData.candidates and jsonData.candidates[1].content.parts[1].text then
                local correctedText = jsonData.candidates[1].content.parts[1].text

                vibrate()

                if config.autoCopy then
                    service.paste(correctedText)
else
                    service.insert(service.getEditText(), correctedText)
                end

                service.speak(correctedText)
            else
                vibrate()

                if config.autoCopy then
                    service.paste(text)
                else
                    service.insert(service.getEditText(), text)
                end

                service.speak(text)
            end
        else
            vibrate()

            if config.autoCopy then
                service.paste(text)
            else
                service.insert(service.getEditText(), text)
            end

            service.speak(text)
        end
    end)
end

local function isEditTextPresent()
    return service.getEditText() ~= nil
end

local function startListening()
    local speechRecognizer = SpeechRecognizer.createSpeechRecognizer(konteks)
    local handler = Handler(Looper.getMainLooper())

    local speechListener = RecognitionListener{
        onResults = function(results)
            local data = results.getParcelableArrayList(SpeechRecognizer.RESULTS_RECOGNITION)
            if data and data.size()> 0 then
                local originalText = data.get(0)
                processText(originalText)
            end
            speechRecognizer.destroy()
        end,
        onError = function(error)
            speechRecognizer.destroy()
        end
}

    local recognizerIntent = Intent(RecognizerIntent.ACTION_RECOGNIZE_SPEECH)
    recognizerIntent.putExtra(RecognizerIntent.EXTRA_LANGUAGE_MODEL, RecognizerIntent.LANGUAGE_MODEL_FREE_FORM)

    speechRecognizer.setRecognitionListener(speechListener)
    speechRecognizer.startListening(recognizerIntent)
end

local function showConfigDialog()
    local layout = {
        ScrollView,
        layout_width = "fill",
        layout_height = "fill",
        {
            LinearLayout,
            orientation = "vertical",
            layout_width = "fill",
            padding = "16dp",
            layout_height = "wrap",
            {
                TextView,
                text = "Salam saya, Jibran, https://t.me/jieshuojm\nBlind is powered!",
                layout_width = "fill",
                layout_height = "wrap_content"
},
            {
                TextView,
                text = "Masukkan API Key Gemini bosku, biar berfungsi:",
                layout_width = "fill",
                layout_height = "wrap_content"
},
            {
                Button,
                text = "Belum punya Apikey?\nKetuk ini!",
                layout_width = "fill",
                layout_height = "wrap",
                backgroundColor = 0xFFBB86FC,
                textColor = 0xFFFFFFFF,
                padding = "12dp",
                onClick = function()
vibrate()
                    pcall(function()
                        service.startActivity(Intent(Intent.ACTION_VIEW, Uri.parse("https://aistudio.google.com/app/apikey")))
                    end)
                    dlg.dismiss()
                end
            },
            {
                EditText,
                id = "apiKeyInput",
                layout_width = "fill",
                layout_height = "wrap_content",
                text = config.apiKey
},
            {
                TextView,
text = "Mau diperintah bagaimana nih Gemini nya bos?",
                layout_width = "fill",
                layout_height = "wrap_content"
},
            {
                EditText,
                id = "customInstructionInput",
                layout_width = "fill",
                layout_height = "wrap_content",
                text = config.customInstruction
},
            {
                Switch,
                id = "useGeminiSwitch",
                text = "Gunakan Gemini untuk Diktasi",
                checked = config.useGeminiForDictation
},
            {
                Switch,
                id = "vibrationSwitch",
                text = "Efek Getar",
                checked = config.enableVibration
},
            {
                Switch,
                id = "autoCopySwitch",
                text = "Salin hasil dikte",
                checked = config.autoCopy
},
            {
                Button,
                id = "saveButton",
                text = "Simpan konfigurasi",
                layout_width = "fill",
                layout_height = "wrap_content",
                onClick = function()
                    config.apiKey = apiKeyInput.getText().toString()
                    config.customInstruction = customInstructionInput.getText().toString()
                    config.useGeminiForDictation = useGeminiSwitch.isChecked()
                    config.enableVibration = vibrationSwitch.isChecked()
                    config.autoCopy = autoCopySwitch.isChecked()
                    saveConfig(config)
                    vibrate() dlg.dismiss() service.speak("Sukses disimpan bosku😘🥳")
                end
}
}
}

    dlg = LuaDialog(konteks)
dlg.setTitle("Wih, halo bosku...")
    dlg.setView(loadlayout(layout))
dlg.setButton("Tutup", function() vibrate()
    dlg.dismiss()
end)
    vibrate() service.playSoundTick() dlg.show()
end

if isEditTextPresent() then
    startListening()
else
showConfigDialog()
end


